function love.load()
	w, h = love.graphics.getDimensions()
	
	pos = {
		x = 0,
		y = 0,
	}
end

-- a black/white mask image: black pixels will mask, white pixels will pass.
char1 = love.graphics.newImage("char.png")
char2 = love.graphics.newImage("char2.png")
stroke = love.graphics.newImage("stroke.png")
 
local mask_shader = love.graphics.newShader[[
   vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
      if (Texel(texture, texture_coords).rgb == vec3(0.0)) {
         // a discarded pixel wont be applied as the stencil.
         discard;
      }
      return vec4(1.0);
   }
]]
 
function charDraw()
   love.graphics.setShader(mask_shader)
   love.graphics.draw(char1, pos.x, pos.y)
   love.graphics.setShader()
end

function char2Draw()
   love.graphics.setShader(mask_shader)
   love.graphics.draw(char2, w/2, 0)
   love.graphics.draw(stroke, 0, 0)
   love.graphics.setShader()
end
 
function love.draw()
    love.graphics.stencil(charDraw, "increment", 1)
	love.graphics.stencil(char2Draw, "increment", 1, true)
    love.graphics.setStencilTest("equal", 1)
	love.graphics.setColor(255, 0, 0, 255)
    love.graphics.rectangle("fill", 0, 0, w, h)
	love.graphics.setStencilTest("greater", 1)
	love.graphics.setColor(0, 255, 0, 255)
    love.graphics.rectangle("fill", 0, 0, w, h)
    love.graphics.setStencilTest()
end

function love.update(dt)
	if love.keyboard.isDown("a") then
		pos.x = pos.x - dt*300
	end
	if love.keyboard.isDown("d") then
		pos.x = pos.x + dt*300
	end
end